#ifndef XL_SPRITE_H
#define XL_SPRITE_H

#include <psone/bladeps.h>

typedef struct XL_SPRITE_STRUCT
{
	int total_frame;
	int frame;
	int frame_rate;
	int tick;
	GsIMAGE tim;
	GsSPRITE sprite;
}XL_SPRITE;

void LoadSprite(u_char *source, XL_SPRITE *sprite);
void LoadAniSprite(u_char *source, XL_SPRITE *sprite, int total_frame, int frame_rate, int sprite_width, int sprite_height);

void PrepareSprite(XL_SPRITE *sprite);
void RefreshSpriteFrame(XL_SPRITE *sprite);

void PlaceSprite(XL_SPRITE *sprite, int x, int y);
void MoveSprite(XL_SPRITE *sprite, int add_x, int add_y);
void ScaleSprite(XL_SPRITE *sprite, float scale_x_ratio, float scale_y_ratio);
void RotateSprite(XL_SPRITE *sprite, float angle_ratio);
void ChangeSpriteRGB(XL_SPRITE *sprite, int red, int green, int blue);
void ChangeSpriteBrightness(XL_SPRITE *sprite, int brightness);

void GetSpriteLoc(XL_SPRITE *sprite, int *x, int *y);
void SetSpriteFrame(XL_SPRITE *sprite, int frame, int absolute);

#endif
