#include "xl_tile.h"

void DrawBorder(GsTILE *tile, int r, int g, int b, int x, int y, int w, int h)
{
	GsLINE top;
	GsLINE down;
	GsLINE left;
	GsLINE right;

	top.r = r;
	top.g = g;
	top.b = b;
	top.x0 = x;
	top.y0 = y;
	top.x1 = x+w;
	top.y1 = y;

	down.r = r;
	down.g = g;
	down.b = b;
	down.x0 = x;
	down.y0 = y+h;
	down.x1 = x+w;
	down.y1 = y+h;

	left.r = r;
	left.g = g;
	left.b = b;
	left.x0 = x;
	left.y0 = y;
	left.x1 = x;
	left.y1 = y+h;

	right.r = r;
	right.g = g;
	right.b = b;
	right.x0 = x+w;
	right.y0 = y;
	right.x1 = x+w;
	right.y1 = y+h;

	GsSortLine(&top);
	GsSortLine(&down);
	GsSortLine(&left);
	GsSortLine(&right);
	GsSortTile(tile);
}

void DrawBox(GsTILE *tile, int r, int g, int b, int a, int x, int y, int w, int h)
{
	int color_offset = 10;

	GsLINE top;
	GsLINE down;
	GsLINE left;
	GsLINE right;

	top.r = r + color_offset;
	top.g = g + color_offset;
	top.b = b + color_offset;
	top.x0 = x;
	top.y0 = y;
	top.x1 = x+w;
	top.y1 = y;

	down.r = r - color_offset;
	down.g = g - color_offset;
	down.b = b - color_offset;
	down.x0 = x;
	down.y0 = y+h;
	down.x1 = x+w;
	down.y1 = y+h;

	left.r = r + color_offset;
	left.g = g + color_offset;
	left.b = b + color_offset;
	left.x0 = x;
	left.y0 = y;
	left.x1 = x;
	left.y1 = y+h;

	right.r = r - color_offset;
	right.g = g - color_offset;
	right.b = b - color_offset;
	right.x0 = x+w;
	right.y0 = y;
	right.x1 = x+w;
	right.y1 = y+h;

	tile->r = r;
	tile->g = g;
	tile->b = b;

	if(a > 4 || a < 0)
	{
		tile->trans = 0;
	}
	else
	{
		tile->trans = a;
	}

	tile->x = x;
	tile->y = y;
	tile->w = w;
	tile->h = h;

	GsSortLine(&top);
	GsSortLine(&down);
	GsSortLine(&left);
	GsSortLine(&right);
	GsSortTile(tile);
}

// create a tile
void CreateTile(GsTILE *tile, int r, int g, int b, int a, int x, int y, int w, int h)
{
	tile->r = r;
	tile->g = g;
	tile->b = b;

	if(a > 4 || a < 0)
	{
		tile->trans = 0;
	}
	else
	{
		tile->trans = a;
	}

	tile->x = x;
	tile->y = y;
	tile->w = w;
	tile->h = h;
}

// put the tile to graphic buffer queue
void PrepareTile(GsTILE *tile)
{
	// add the tile to the graphics queue
	GsSortTile(tile);
}
